;****************************************************************************
;* Copyright (C) 2002 Andrea Zicchetti (aka Asus)
;*
;* This program is free software; you can redistribute it and/or modify
;* it under the terms of the GNU General Public License as published by
;* the Free Software Foundation; either version 2 of the License, or
;* (at your option) any later version.
;*
;* This program is distributed in the hope that it will be useful,
;* but WITHOUT ANY WARRANTY; without even the implied warranty of
;* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;* GNU General Public License for more details.
;*
;* You should have received a copy of the GNU General Public License
;* along with this program; if not, write to the Free Software
;* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;****************************************************************************

%include "libconnect.h"
%define STRLEN_post 12
%define STRLEN_connect 8
%define STRLEN_http 11
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
global connect:function
extern _GLOBAL_OFFSET_TABLE_            ;definisco il GOT
extern _errno
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
segment .data
RELAYSTRING0 db 'POST http://'
RELAYSTRING1 db 'CONNECT '
RELAYSTRING2 db ' HTTP/1.0',10,10,0
%include "parseconf.h"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
segment .bss
SOCKADDR resb 128	;spazio riservato alla struttura sockaddr_in
RELAYSTR resb 100	;la nostra stringa di relay da mandare al proxolo
BUFFER resb 256
ARGS:			;args  l'indirizzo dei 3 argomenti da passare alle varie funzioni della socketcall
ARG0 resd 1	
ARG1 resd 1
ARG2 resd 1
buffer resb DIMLINEA
STRUCTPROXY resd 3
;|proxycorrente(4)|portacorrente(2)|contatoreproxycorrente(1)|flagusato(1)|type(1)|discard(2)|free(1)|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
segment .text
connect:
	enter (128+8+4),0
;        struttura fd_set (128 bytes)
;        struttura struct timeval (8 bytes)
;        optval generico di getsockopt (4 bytes)
        push ebx
	push ecx
	push edx
	push esi
	push edi
	pushfd
        call .calc_GOT
.calc_GOT: 
	pop ebx       ;codice standard per le librerie condivise
        add ebx,_GLOBAL_OFFSET_TABLE_+$$-.calc_GOT wrt ..gotpc     ;ebx serve per accedere ai segmenti .data e .bss nelle librerie condivise
        ; ***** INIZIO DELLA FUNZIONE *****
	push ebx	;salviamo subito ebx che ci siamo calcolati con tanta fatica
	;start
	mov edx,[ebp+12]	;in edx metto l'indirizzo della struttura sockaddr_in, connect(fd,*sockaddr,socklen)
	cmp word [edx],AF_INET	;il protocollo che stiamo utilizzando  AF_INET?
	jnz near old_connect	;se non stiamo utilizzando questo protocollo usiamo un clone della vecchia connect() delle libc
	;dobbiamo mantenere invariato solo edx visto che ebx l'abbiamo pushato. controlliamo con getsockopt se il socket  dgram
        mov eax,SOCKETCALL
        mov ebx,GETSOCKOPT
        push dword 4    ;pusho la dimensione di optval, un int
        push esp        ;push esp, cio l'indirizzo di optlen
        lea ecx,[ebp-OFFSET_optval]
        push ecx        ;4 argomento, indirizzo di optval
        push dword SO_TYPE ;3 argomento, SO_ERROR
        push dword SOL_SOCKET   ;2 argomento, SOL_SOCKET
        push dword [ebp+8]      ;passo il socket descriptor
        mov ecx,esp
        int 80h         ;chiamiamo socketcall-getsockopt. se SO_ERROR  0 la connessione ha avuto successo
        add esp,24
        cmp dword [ebp-OFFSET_optval],SOCK_DGRAM
	jz near old_connect

;;;;;;;;;;;;;;;;;;;;; parsiamo il file di conf solo se stiamo utilizzando il protocollo AF_INET e il socket  SOCK_STREAM
	push dword [esp]  ;alla funzione parseconf passiamo ebx (il GOT)
	mov edx,[edx+4]
	push edx	;passiamo anche l'ip al quale dobbiamo connetterci
	call parseconf
	add esp,4
	pop ebx		;ripristiniamo il got
	cmp eax,1
	jz near old_connect
	mov byte [ebx+STRUCTPROXY+7 wrt ..gotoff],1   ;imposto a uno la flag 'used' della struttura proxy

        push dword WRITE
        call setgetstructproxy
        add esp,4

	mov edx,[ebp+12]    ;     puntatore a struct sockaddr_in
	mov eax,SOCKETCALL        ;primo argomento della syscall; #define __NR_socketcall  102 (unistd.h)
	mov word [ebx+SOCKADDR wrt ..gotoff],AF_INET      ;riempiamo la struttura SOCKADDR, iniziamo con il protocollo
	mov cx,[ebx+STRUCTPROXY+4 wrt ..gotoff]
	movzx ecx,cx       ;Ecx contiene la porta ora
	push edx       ;salviamo edx
	mov edx,ecx
	and ecx,0ff00h
	shr ecx,8
	and edx,0ffh
	shl edx,8
	or ecx,edx
	mov word [ebx+SOCKADDR+2 wrt ..gotoff],cx
	pop edx ;ripristino edx
;;;;;;;	
	mov ecx,[ebx+STRUCTPROXY wrt ..gotoff]
	mov [ebx+SOCKADDR+4 wrt ..gotoff],ecx
	mov ecx,[ebp+8]	;prendo dallo stack il socket descriptor (primo parametro passato dal programma C che 'ci' sta chiamando, ricordo ancora: connect(int  sockfd,  const  struct  sockaddr  *serv_addr, socklen_taddrlen);)
	mov dword [ebx+ARG0 wrt ..gotoff],ecx ;il primo argomento della struttura ARGS  il socket descriptor
	lea ecx,[ebx+SOCKADDR wrt ..gotoff] ;in ecx mettiamo l'indirizzo della struttura
	mov [ebx+ARG1 wrt ..gotoff],ecx   ;in ARG1 carichiamo l'indirizzo della struttura SOCKADDR
	mov dword [ebx+ARG2 wrt ..gotoff],128     ;in ARG2 mettiamo la dimensione della struttura
	lea ecx,[ebx+ARGS wrt ..gotoff]    ;terzo argomento della syscall, l'indirizzo del primo argomento (arg0)
	mov ebx,CONNECT      ;il secondo argomento della syscall  la funzione connect
	int 80h	;***** ci siamo connessi al proxy ***** (se tutto  andato bene ovviamente)
	push eax ;salviamo cosa ha ritornato la connect() al proxy
	test eax,eax ;se qualcosa  andato storto controlliamo se il socket  non blocking, se s eseguiamo select/getsockopt (eax!=0)
	jz .connected

        call fcntl_getfl
        and eax,O_NONBLOCK      ;and mette in evidenza i bit comuni
        xor eax,O_NONBLOCK      ;con xor verifico che i bit comuni corrispondano a O_NONBLOCK
	jnz near .end

	call selecttocheckconnection
	test eax,eax	;controlliamo eax, se  zero non ci siamo connessi
	jz near .end  ;era short

	call getsockopttocheckconnection
        cmp dword [ebp-OFFSET_optval],0
	jnz near .end
	mov dword [esp],0	;cambio l'uscita della connect precedente in 0 (riuscita)
.connected:
	mov ebx,[esp+4]	;in ebx rimettiamo il GOT calcolato all'inizio (+4 xk abbiamo appena pushato eax)
	mov ax,[edx+2]	    ;ax contiene la porta (da swappare)  (skippiamo i primi 2 bytes che contengono il protocollo)
	movzx ecx,al	;*TODO: riscrivere sto schifo
	shl ecx,8       
	movzx eax,ah
	add ecx,eax	    ;ecx contiene la PORTA IN NUMERO INTERO 
	mov eax,[edx+4]     ;primi 2 bytes di protocollo, 2 di porta, skippati
	call request_to_proxy
	mov eax,WRITE       ;scriviamo la richiesta al proxy, edx l'abbiamo appena settato alla fine della funzione request_to_proxy
	lea ecx,[ebx+RELAYSTR wrt ..gotoff] ;in ecx mettiamo l'indirizzo della stringa
	;edx l'abbiamo settato alla fine di request to proxy
	mov ebx,[ebp+8] ;il socket descriptor
	int 80h
	mov ebx,[esp+4]	;rimettiamo in ebx il GOT (+4 xk abbiamo pushato eax)
; fixed
	mov dx,[ebx+STRUCTPROXY+9 wrt ..gotoff]
	movzx edx,dx
	test edx,edx	     ;se per caso non vogliamo scartare niente usciamo
	jz .fin
	
	mov dword [ebp-OFFSET_timeval],RTIMEOUT_SEC
        mov dword [ebp-OFFSET_timeval+4],RTIMEOUT_USEC   ;imposto i timeout per la select
        lea eax,[ebp-OFFSET_timeval]
        push eax
	push dword NULL
        push dword NULL
        lea eax,[ebp-OFFSET_fdset]
        push eax
        push dword [ebp+8]      ;socket descriptor
        call select
        add esp,20
	test eax,eax	;abbiamo eseguito la select, se non c'e' niente da leggere skippiamo tutto
	jz .fin
	
	;mov esi,ecx	;salviamo ecx ed ebx che verranno modificati dopo
	mov edi,ebx
	mov eax,READ		;ora leggiamo xxx bytes dal socket descriptor
	;edx e' gia' settato precedentemente
	sub esp,edx	;facciamo posto per discard posti
;	lea ecx,[ebx+BUFFER wrt ..gotoff]
	mov ecx,esp

;	mov dx,[ebx+STRUCTPROXY+9 wrt ..gotoff]	;mettiamo il contenuto di discard in dx->edx
;	movzx edx,dx	;discard  gi contenuto in edx
	mov ebx,[ebp+8]	;il socket descriptor
	int 80h
	mov ebx,edi	;ripristiniamo ebx ed ecx
	;mov ecx,esi
	add esp,edx
.fin:
        mov ecx,100		;riempiamo RELAYSTR di \0
        lea edi,[ebx+RELAYSTR wrt ..gotoff]
        xor eax,eax
        rep stosb
.end:	
	pop eax ;ripristino l'uscita della connect
        test eax,eax	;ora impostiamo errno, se eax  negativo
        jns .popregs	;rendiamolo positivo e mettiamolo in errno
        neg eax		;in eax va -1 (errore)
        mov [_errno],eax	;se eax  positivo ritorniamo senza settare
        mov eax,-1	;errno
.popregs:
	;end
	add esp,4	    ;rimuovo l'ebx che contiene il GOT pushato all'inizio
	; ***** FINE DELLA FUNZIONE *****
	popfd
	pop edi	;ripristiniamo tutti i registri che abbiamo modificato tranne eax che contiene l'uscita di connect()
	pop esi
	pop edx
	pop ecx
        pop ebx
	leave
        ret

old_connect:	;questa funzione fa qualcosa di simile alla connect() delle libc
        mov eax,SOCKETCALL	;argomenti della syscall
        mov ebx,CONNECT
	lea ecx,[ebp+8]		;mettiamo in ecx l'INDIRIZZO degli argomenti passati dal programma che ci ha chiamato
	int 80h
	push eax	;salviamo il valore di ritorno di connect()
	test eax,eax ;se qualcosa  andato storto controlliamo se il socket  non blocking ed eventualmente facciamo il controllo select/getsockopt (eax!=0)
	jz connect.end
	call fcntl_getfl
	and eax,O_NONBLOCK	;and mette in evidenza i bit comuni
	xor eax,O_NONBLOCK	;con xor verifico che i bit comuni corrispondano a O_NONBLOCK, lo xor darebbe zero
	jnz connect.end

        call selecttocheckconnection
        test eax,eax    ;controlliamo eax, se  zero non ci siamo connessi
        jz connect.end  

        call getsockopttocheckconnection
        cmp dword [ebp-OFFSET_optval],0
        jnz connect.end
        mov dword [esp],0       ;cambio l'uscita della connect precedente in 0 (riuscita)

	;testtest
	;mov dword [esp],0
	;mov ebx,[esp+4]
	;;finetest
	jmp connect.end


request_to_proxy:        ;ecx porta, eax ip
	push ecx	;pushamo la porta, non togliere plz
	cld	;settiamo il direction flag
;new code
	cmp byte [ebx+STRUCTPROXY+8 wrt ..gotoff],0	;controllo il tipo di proxy che devo usare
	jnz .POST
	mov ecx,STRLEN_connect	;CONNECT+(spazio), lunghezza
	lea esi,[ebx+RELAYSTRING1 wrt ..gotoff]
	jmp .continue
.POST:
	mov ecx,STRLEN_post  ;POST(spazio)http://, lunghezza
	lea esi,[ebx+RELAYSTRING0 wrt ..gotoff]
.continue:
	lea edi,[ebx+RELAYSTR wrt ..gotoff]
        rep movsb	;in RELAYSTR copiamo CONNECT+spazio o POST http://
	push ebx	;salviamo ebx che verr modificato nelle seguenti funzioni
	call insert_ip  ;in eax c' gi l'ip
	pop ebx		;ripristiniamo ebx (questo salva/ripristina  eseguito +volte nelle righe seguenti)
	mov byte [edi],":"	;aggiungiamo un : dopo l'ip (dobbiamo mandare al proxy CONNECT IP:PORTA)
	inc edi
	pop eax   ;la porta
	push ebx
	call insert_string
	pop ebx

	cmp byte [ebx+STRUCTPROXY+8 wrt ..gotoff],1  ;controllo se il proxy e' di tipo POST
	jnz .addhttp
	mov byte [edi],"/"
	inc edi
.addhttp:
	cld     ;settiamo il direction flag
        mov ecx,STRLEN_http       ;lunghezza di " HTTP/1.0,10,10"
	lea esi,[ebx+RELAYSTRING2 wrt ..gotoff]	;nel source index mettiamo l'indirizzo di relaystring2
	rep movsb	;copiamo in RELAYSTR la stringa RELAYSTRING2
	mov edx,edi	;dobbiamo calcolare la lunghezza della stringa prodotta, edi-inizio di relaystr (edi  l'indirizzo corrente, e lo mettiamo in edx)
	lea edi,[ebx+RELAYSTR wrt ..gotoff] ;mettiamo in edi l'indirizzo dell'inizio della stringa
	sub edx,edi	;facciamo la sottrazione
	ret

insert_string:  ;in eax abbiamo il parametro    ;registri modificati ecx edx eax esi edi ebx
	push ebp
	mov ebp,esp
	xor ecx,ecx	;azzeriamo ecx che conta i caratteri inseriti
        mov ebx,10   ;in ebx c' il divisore (10)
.lo:    inc ecx
        xor edx,edx
        div ebx       ;divido per ebx, risultato in eax, resto in edx
        add edx,'0'   ;aggiungiamo al resto il codice ascii del carattere '0' cos otteniamo un carattere immediatamente printabile
	dec esp	      ;facciamo spazio per il carattere appena ottenuto sullo stack
        mov byte [esp],dl      ;metto il carattere sullo stack
        test eax,eax  ;se il dividendo  uguale a zero mi fermo altrimenti ripeto
        jnz .lo		;ora abbiamo sullo stack il numero che risulta ribaltato rispetto a come l'abbiamo inserito
	cld		;non ci resta che copiarlo nel verso giusto nella stringa RELAYSTR. edi punta alla posizione corrente di RELAYSTR
	lea esi,[esp]   ;il source index deve puntare allo stack
	rep movsb	;in ecx abbiamo gi il numero di caratteri inseriti, non ci resta che copiare
	mov esp,ebp	
	pop ebp
        ret

insert_ip:
	push eax   ;pusho l'ip
	movzx eax,al
	call insert_string 
        mov byte [edi],"."
        inc edi
	mov eax,[esp]
	movzx eax,ah
	call insert_string
	mov byte [edi],"."
        inc edi
	mov eax,[esp]
	shr eax,16
        movzx eax,al
        call insert_string
        mov byte [edi],"."
        inc edi
        mov eax,[esp]
	shr eax,16
        movzx eax,ah
        call insert_string
	add esp,4
	ret

select:               
	push ebp
	mov ebp,esp
	push ebx
	push ecx
	push edx
	push esi
	push edi
	FD_ZERO
	mov ebx,[ebp+8]      ;il socket descriptor bisogna incrementarlo di uno
	push ebx		;pushamo il socket descriptor, NON dobbiamo incrementarlo di uno
	call FD_SET
	add esp,4
	inc ebx
	mov ecx,[ebp+12]
	mov edx,[ebp+16]
	mov esi,[ebp+20]
	mov edi,[ebp+24]
	mov eax,SELECT
	int 80h		;abbiamo chiamato la select, 1  = possiamo checkare se siamo connessi, zero = qualcosa andato storto
	pop edi
	pop esi
	pop edx
	pop ecx
	pop ebx
	pop ebp
	ret	

selecttocheckconnection:
	mov dword [ebp-OFFSET_timeval],CTIMEOUT_SEC
        mov dword [ebp-OFFSET_timeval+4],CTIMEOUT_USEC   ;imposto i timeout per la select
        lea eax,[ebp-OFFSET_timeval]
        push eax
        push dword NULL
        lea eax,[ebp-OFFSET_fdset]
        push eax
        push dword NULL
        push dword [ebp+8]      ;socket descriptor
        call select
        add esp,20
	ret


getsockopttocheckconnection:
	mov eax,SOCKETCALL
        mov ebx,GETSOCKOPT
        push dword 4    ;pusho la dimensione di optval, un int
        push esp        ;push esp, cio l'indirizzo di optlen
        lea ecx,[ebp-OFFSET_optval]
        push ecx        ;4 argomento, indirizzo di optval
        push dword SO_ERROR ;3 argomento, SO_ERROR
        push dword SOL_SOCKET   ;2 argomento, SOL_SOCKET
        push dword [ebp+8]      ;passo il socket descriptor
        mov ecx,esp
        int 80h         ;chiamiamo socketcall-getsockopt. se SO_ERROR  0 la connessione ha avuto successo
        add esp,24
	ret


fcntl_getfl:
	push ebx
	push ecx
	mov eax,FCNTL
	mov ebx,[ebp+8]	;socket descriptor     ;l'ebp  quello della funzione che ci chiama
	mov ecx,F_GETFL
	int 80h
	pop ecx
	pop ebx
	ret

FD_SET:
        push eax
        push ebx
        mov eax,[esp+12]                ;il file descriptor
        mov ebx,[ebp]   ;ebp
        bts [ebx-OFFSET_fdset],eax
        pop ebx
        pop eax
        ret

%include "parseconf.asm"
