;****************************************************************************
;* Copyright (C) 2002 Andrea Zicchetti (aka Asus)
;*
;* This program is free software; you can redistribute it and/or modify
;* it under the terms of the GNU General Public License as published by
;* the Free Software Foundation; either version 2 of the License, or
;* (at your option) any later version.
;*
;* This program is distributed in the hope that it will be useful,
;* but WITHOUT ANY WARRANTY; without even the implied warranty of
;* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;* GNU General Public License for more details.
;*
;* You should have received a copy of the GNU General Public License
;* along with this program; if not, write to the Free Software
;* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;****************************************************************************

parseconf:
	push ebp
	mov ebp,esp
	push dword 0      ;struttura proxy_select  --> free(1)|discard(2)|type(1)
	push dword 0      ;12 bytes			proxysettato(1)|contatore(1)|porta(2)
	push dword 0	  ;				ip(4)
	push dword 0	;spazio per 8 bytes, cio 8-1 campi del file di configurazione
	push dword 0
	mov ebx,[ebp+12]	;got
	mov byte [ebx+STRUCTPROXY+6 wrt ..gotoff],0    ;azzeriamo il contatore del proxy corrente, utile se non vogliamo cyclare i proxy
	;infatti se il tmpfile  linkato a devnull la successiva read non modifica la STRUCTPROXY
	push dword READ
	call setgetstructproxy
	add esp,4

	mov eax,OPEN	;apriamo il file
	mov ebx,config
	mov ecx,O_RDONLY
	int 80h		;in eax abbiamo il file descriptor o x<0 in caso di errore
	test eax,eax
	js near .cleanup
	mov ebx,[ebp+12]	;mettiamo in ebx il GOT
	lea ecx,[ebx+buffer wrt ..gotoff]   ;ecx=indirizzo di buffer
	push eax    ;il file descriptor	;sullo stack abbiamo il file descriptor
	mov ebx,eax   ;in ebx mettiamo il file descriptor
	xor edi,edi     ;edi conta il numero di caratteri letti
	xor esi,esi     ;esi conta quanti campi ho gi trovato
.lo:
	mov eax,READ	;leggiamo un carattere alla volta fino all'EOF o ad un \n
	mov edx,1	;1carattere x volta
	int 80h
	test eax,eax	;controllo se ho raggiunto l'EOF (eax=0)
	jz near .chkproxy	;chiudo il file
        ;;;;;;;;;;;;;;;;; inizio i controlli ;;;;;;;;;;;;;;;;;;
	cmp byte [ecx],'#'   ;il carattere  un cancelletto? se s scartiamo tutta la riga
	jz .hole
	cmp byte [ecx],' '   ;il carattere letto  1spazio? se s scartiamo tutto fino a fine riga
	jz .hole
	cmp byte [ecx],9     ;il carattere letto  un tab? idem come sopra, scartiamo tutto
	jz .hole
	cmp edi,DIMLINEA ;non  che ho letto gi abbastanza caratteri?
	jnae .nextcontrol	 ;se ho gi letto troppi caratteri parso la linea corrente e passo alla prossima
.hole:
	push ecx	;salvo la posizione corrente di ecx, puntatore a buffer; in ebx ho gi i file descriptor, in edx ho gi la dimensione 1
	sub esp,1	;faccio posto sullo stack per un carattere
		mov ecx,esp   ;ecx ora punta allo spazio libero appena fatto sullo stack
.scarta:	mov eax,READ
		int 80h	;leggo 1carattere
		test eax,eax      ;il file  finito per caso?
		js .nextline
		cmp byte [esp],10	;ho trovato il \n?
		jnz .scarta		;altrimenti continuo a leggere
		add esp,1		;rimuoviamo lo spazio fatto sullo stack
		pop ecx			;ripristiniamo ecx
	jmp .nextline
.nextcontrol:
	cmp byte [ecx],10	;altrimenti controllo se ho trovato un \n
	jz .nextline		;se ho trovato un \n inizio a parsare la riga letta altrimenti faccio altri controlli
	cmp byte [ecx],'/'      ;ho trovato il separatore di campi /?
	jz .updatestruct
	cmp byte [ecx],':'	;ho trovato l'altro separatore di campi : ?
	jz .updatestruct
	jmp .nextchar	
.updatestruct:
	cmp esi,MAXFIELDS-1	;quanti campi ho gi trovato? MAXFIELDS=6
	ja .nextchar
	mov edx,edi	;metto in edx il puntatore al carattere corrente
	mov [ebp+esi-OFFSET_fields],dl	;metto nella struttura il contatore al carattere corrente
	inc esi
.nextchar:
	inc edi         ;incremento il contatore dei caratteri
	inc ecx	;incremento indirizzo
	jmp .lo
.nextline:
	mov edx,edi
	mov byte [ebp+esi-OFFSET_fields],dl	;metto la lunghezza della stringa nella struttura dei campi
	mov byte [ebp+esi-OFFSET_fields+1],0	;metto il terminatore \0 dopo l'ultimo campo trovato,dovrebbe essere inutile ma x sicurezza lo mettiamo
	call parse     ;edi = caratteri della linea
			;in eax ho l'ip, in edx la mask oppure zero
	test eax,eax
	jz .continua
	mov ecx,[ebp+8]    ;in ecx ora abbiamo l'ip
	xor ecx,eax     ;facciamo uno xor tra l'ip a cui dobbiamo connetterci e l'ip del conf
	bsf ebx,ecx	;scanniamo in avanti ecx e troviamo dove iniziano a differire i 2 ip
	jz .success	;se i 2 ip sono uguali il bsf ha settato il zero flag, devo skippare l'ip
	test edx,edx    
        jz .continua	;se sono qui vuol dire che i 2 ip sono diversi ed edx=0
	cmp ebx,edx	;compariamo ebx con la mask del config, se siamo qui ebx ed edx != 0
	jl .continua	;se la mask trovata  maggiore = di quella del config, devo skippare, altrimenti continuo
.success:			;se sono arrivato qui vuol dire che devo skippare l'ip
	mov eax,1	;setto eax=1 come risultato di questa funzione (=1 cio bisogna skippare)
	jmp .chiudi
.continua:
	mov ebx,[ebp+12]	;GOT
	lea ecx,[ebx+buffer wrt ..gotoff]	;metto in ecx l'indirizzo dell'inizio della stringa
	mov ebx,[esp]	;in ebx il file descriptor
	xor esi,esi	;azzero esi ed edi
	xor edi,edi
	jmp .lo
						;controllo lo stato del proxy
.chkproxy:
	;NON POSSO MODIFICARE EAX IN NESSUN MODO
	mov ebx,[ebp+12]
        cmp byte [ebp-OFFSET_structproxy+7],0      ;controllo la flag proxysettato sullo stack
        jnz .chiudi	;se la flag proxysettato  1 esco senza modificare nulla
;        mov ecx,[ebp-4]	;metto in ecx l'ip
;        mov [ebx+STRUCTPROXY wrt ..gotoff],ecx	;salvo l'ip
;        mov cx,[ebp-6]	;metto in cx la porta
;        mov [ebx+STRUCTPROXY+4 wrt ..gotoff],cx     ;salvo la porta
	cld
	lea esi,[ebp-OFFSET_structproxy]
	lea edi,[ebx+STRUCTPROXY wrt ..gotoff]
	mov ecx,3  ;voglio salvare l'ip (4bytes) e la porta (2bytes), ma gi che ci sono copio tutta la struttura
	rep movsd	;dword*3=12 bytes=SIZEOF_structproxy

        mov byte [ebx+STRUCTPROXY+7 wrt ..gotoff],0   ;imposto a zero la flag 'used'
        mov byte [ebx+STRUCTPROXY+6 wrt ..gotoff],1   ;imposto ad uno il contatore nella struttura
	;mov cx,[ebp-10]	;metto in cx il tipo del proxy e il discard
	;mov byte [ebx+STRUCTPROXY+8 wrt ..gotoff],ch	;updato la struttura
	;mov byte [ebx+STRUCTPROXY+9 wrt ..gotoff],cl     ;magari  invertito
	

.chiudi:                ;se a chiudi ci arriviamo quando il file 'finisce', eax  zero... se ci arriviamo jumpati dal test di poco sopra eax=1 (cio bisogna skippare)
	mov ebx,[esp]
	push eax
	mov eax,CLOSE
	int 80h
	pop eax
.cleanup:                    ;sto per uscire
	mov ebx,[ebp+12]	;GOT

	push dword WRITE          ;scriviamo nel file le modifiche fatte alla struttura
        call setgetstructproxy
        add esp,4

	mov esp,ebp
	pop ebp
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

parse:  
	xor eax,eax	;eax conterr le somme, lo azzero anche perch se la riga  di 0 caratteri evito di parsarla e cos posso ritornare alla funzione che mi ha chiamato un eax=0 (cio nessun host da skippare)
	xor edx,edx	;edx contiene i caratteri presi dal buffer E alla fine uno dei 2 risultati. serve azzerarlo x forza
	test edi,edi	;se ho letto 0 caratteri non parso nemmeno la riga
	jz .end
;;;;;;;;;;;;;;;;;;;;;;;;;;;; cerco di identificare la funzione di ogni riga del config
        mov ebx,[ebp+12]	;mi assicuro che in ebx ci sia il got
	cmp byte [ebx+buffer wrt ..gotoff],'s'
	jnz .nextcondition
	call .skip	;se ho trovato il carattere che identifica una linea di skip...vado alla sezione relativa agli skip
	;jmp .end
	ret	;esco da parse
.nextcondition:
	cmp byte [ebx+buffer wrt ..gotoff],'p'
	jnz .nextcondition2
	push dword 0	;type, 0=connect
	jmp .callproxy
.nextcondition2:
	cmp byte [ebx+buffer wrt ..gotoff],'P'
	jnz .end
	push dword 1 ;type 1=POST
.callproxy:
	call .proxy
	add esp,4
;;;;;;;;;;;;;;;;;;;;;;;;;;;; ho riconosciuto l'opzione richiesta nella riga e sono andato ad eseguire il pezzo di codice che la parsa	
.end:	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;se ci sono opzioni sconosciute salto silenziosamente la linea

;;;;;;;;;;;;;;;;;;;;;;; funzione .skip
.skip:	;in ebx VOGLIO il got
	push dword 1    ;voglio il campo 1
	call .split	;split vuole solo ebx=GOT
	add esp,4	;in eax ho il campo 1 trasformato in numero
	test eax,eax	;eax  zero?
	jz .skipend
	mov edx,eax	;salvo eax in edx
	push dword 2    ;voglio il campo 2
        call .split
        add esp,4       ;in eax ho il campo 2 trasformato in numero
	cmp eax,-1
	jnz .found
	mov eax,0
.found:
	xchg eax,edx
.skipend:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;; funzione .proxy
.proxy:
	xor eax,eax  ;ecx lo usiamo come registro temporaneo, cancelliamo eax per fare saltare il controllo degli ip da skippare (se eax=0 non controlliamo gli skip)
        cmp byte [ebp-OFFSET_structproxy+7],0      ;controllo la flag proxysettato sullo stack
	jnz near .exitproxy
	cmp byte [ebx+STRUCTPROXY+6 wrt ..gotoff],0 ;controllo il contatore proxy corrente
	jz .getproxinfo	;se  zero non controllo la flag used
	cmp byte [ebx+STRUCTPROXY+7 wrt ..gotoff],0 ;controllo la flag used
	jnz .getproxinfo
	mov byte [ebp-OFFSET_structproxy+7],1     ;imposto la flag 'proxysettato' sullo stack
	jmp .exitproxy
.getproxinfo:
        push dword 3
        call .split	;trovo (se esiste) il terzo campo
        add esp,4       ;in eax ho il terzo campo, ossia discard
        cmp eax,-1	;se eax e' -1 vuol dire che nel file di configurazione non c'era il terzo campo
        jnz .checkcounters
        mov ax,DISCARD  ;se non h presente nel file di configurazione il campo discard,lo imposto col valore di default
.checkcounters:
	inc byte [ebp-OFFSET_structproxy+6]    ;incremento il contatore sullo stack
        mov cl,byte [ebx+STRUCTPROXY+6 wrt ..gotoff]
        cmp byte [ebp-OFFSET_structproxy+6],cl   ;controllo contatore sullo stack e contatore struttura
        jna .savefirstproxy
        mov [ebx+STRUCTPROXY+9 wrt ..gotoff],ax ;settiamo nella struttura il discard (2bytes)
        mov eax,[esp+4] ;mettiamo in eax il type pushato prima di chiamare proxy(type)
        mov [ebx+STRUCTPROXY+8 wrt ..gotoff],al
	call .skip
        mov [ebx+STRUCTPROXY wrt ..gotoff],eax       ;salvo il proxy nella struttura
        mov [ebx+STRUCTPROXY+4 wrt ..gotoff],dx     ;salvo la porta
        mov byte [ebp-OFFSET_structproxy+7],1     ;imposto la flag 'proxysettato' sullo stack
        mov byte [ebx+STRUCTPROXY+7 wrt ..gotoff],0   ;imposto a zero la flag 'used'
        mov cl,[ebp-OFFSET_structproxy+6]
        mov byte [ebx+STRUCTPROXY+6 wrt ..gotoff],cl ;aggiorno il contatore nella struttura
        ;xor eax,eax     ;cosl saltiamo gli skip
        jmp .exitproxy
.savefirstproxy:
        cmp byte [ebp-OFFSET_structproxy+6],1
        jnz .exitproxy
        mov [ebp-OFFSET_structproxy+9],ax ;settiamo nella struttura il discard
        mov eax,[esp+4] ;mettiamo in eax il type pushato prima di chiamare proxy(type)
        mov [ebp-OFFSET_structproxy+8],al
        call .skip
        mov [ebp-OFFSET_structproxy],eax
        mov [ebp-OFFSET_structproxy+4],dx

.exitproxy:
	xor eax,eax      ;saltiamo gli skip
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.split:	;ebx = GOT necessariamente
	xor eax,eax
	push ebx
	push ecx
	push edx
	push esi
	push edi
	mov edx,[esp+24] ;unico argomento della funzione, il numero del campo che voglio
	cmp byte [ebp+edx-OFFSET_fields],0
	jnz .setpointers
	mov eax,-1
	jmp .exit
.setpointers:
	mov cl,[ebp+edx-OFFSET_fields]	;in cl il campo
	sub cl,[ebp+edx-OFFSET_fields-1] ;cl=cl-[campo-1]
	movzx ecx,cl	;in ecx estendiamo il contenuto del campo, ecx contatore
	dec ecx	;contatore-1
	cmp ecx,0
	jle .exit	;se il contatore  negativo o zero usciamo
	mov al,[ebp+edx-OFFSET_fields-1]	;in al mettiamo il contenuto del campo-1
	movzx eax,al
	lea edi,[ebx+buffer+eax wrt ..gotoff] ;edi punta ora all'inizio del (campo richiesto-1)
	call calcola       ;
.exit:	
	pop edi
	pop esi
	pop edx
	pop ecx
	pop ebx
	ret

calcola:	;ecx contatore, edi indirizzo dell'inizio del campo -1
	push dword 16777216	;pusho 256^3
	push dword 0	;qui alla fine troveremo l'ip se  stato inserito in forma non numerica
        xor eax,eax     ;eax contiene le somme, ecx  stato settato prima di chiamare questa funzione
        mov ebx,1     ;ebx  il moltiplicatore
.cc:
        mov dl,[edi+ecx]	;in dl mettiamo il carattere
	cmp dl,'.'
	jnz .digit
	imul eax,dword [esp+4]	;somma corrente * 256^n
	shr dword [esp+4],8	;256^n/256
	add dword [esp],eax		;somma sullo stack += somma corrente
	xor eax,eax		;somma corrente = 0
	mov ebx,1		;ebx moltiplicatore torna ad 1
	jmp .nextchar
.digit:
        sub dl,'0'
        movzx edx,dl
        imul edx,ebx
        imul ebx,10
        add eax,edx
.nextchar:
        loop .cc        ;quando esco dal ciclo in eax dovrei avere l'ip
	cmp dword [esp],0
	jz .ipnum
	imul eax,dword [esp+4]  ;somma corrente * 256^n
	add eax,dword [esp]           ;somma corrente += somma sullo stack
.ipnum:
	add esp,8
	ret


setgetstructproxy:
	push ebp
	mov ebp,esp
	push eax
	push ebx
	push ecx
	push edx
	mov eax,OPEN
	lea ebx,[ebx+tmpfile wrt ..gotoff]
	cmp dword [ebp+8],READ
	jnz .write_creat
	mov ecx,O_RDONLY
	jmp .okflag
.write_creat:
	mov ecx,(O_WRONLY | O_CREAT)        ;se non c' il file lo creo
.okflag:
	mov edx,416		;permessi del file che eventualmente creo, 640 in ottale  416 in base10
	int 80h       ;ho aperto il file temporaneo
	test eax,eax
	js .fine
	mov ebx,[esp+8]     ;ripristino il GOT
	lea ecx,[ebx+STRUCTPROXY wrt ..gotoff]    ;in ecx l'indirizzo della struttura
	mov ebx,eax	;in ebx il file descriptor
	mov eax,[ebp+8]         ;l'unico parametro di setgetstructproxy  READ o WRITE
	mov edx,SIZEOF_structproxy	;in edx la dimensione da leggere o scrivere
	int 80h		;ora ho letto o scritto... in eax ho la dimensione
	push ebx	;salvo il filedescriptor
	cmp dword [ebp+8],READ	;ho letto?
	jnz .closefiledes
	cmp eax,SIZEOF_structproxy ;ho letto la dimensione reale di structproxy?
	jae .closefiledes
	test eax,eax	;se ho letto zero caratteri esco, altrimenti sefgault
	jz .closefiledes
	mov edi,ecx 	;ecx contiene l'indirizzo della struttura
	dec edi		;lo decremento xk "calcola" vuole indirizzo-1
	mov ecx,eax	;in ecx metto quanto ho letto
	call calcola	;in eax ho il numero contenuto nel file
	dec eax
	mov ebx,[esp+12]     ;ripristino il GOT
	mov byte [ebx+STRUCTPROXY+6 wrt ..gotoff],al	;mettiamo proxy-1
	mov byte [ebx+STRUCTPROXY+7 wrt ..gotoff],1	;flag usato=1 yess
.closefiledes:
	pop ebx
	mov eax,CLOSE      ;ebx contiene gi il file descriptor
	int 80h
.fine:
	pop edx
	pop ecx
	pop ebx
	pop eax
	pop ebp
	ret
